package com.javacodegeeks.examples;

/**
 * This class is a demo to explain multi-dimensional arrays.
 * 
 * @author Shivakumar Ramannavar
 */
public class MultidimensionalArrayExample {

	/**
	 * Try 1-D array
	 */
	public void try1DArray() {
		System.out.println("Trying the 1-D array");
		System.out.println("====================");

		int numberOfNumbers = 10;

		// Initialise an array of numbers
		int[] arrayOfIntegers = new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };

		System.out.printf("There are %d numbers in the array. ", numberOfNumbers);

		// Changing the fifth element to 10, index is 4
		System.out.println("The element at the 5th position is:" + arrayOfIntegers[4]);
		System.out.println("Modifying the item at arrayOfIntegers[4]. " + "Assigning the value to 10.");
		arrayOfIntegers[4] = 10;
		System.out.println("The updated element at the 5th position is :" + arrayOfIntegers[4]);
	}

	/**
	 * Try 2-D array
	 */
	public void try2DArray() {
		System.out.println("\n\nTrying the 2-D array");
		System.out.println("====================");

		int numOfRows = 4;
		int numOfSeatsInEachRow = 6;

		System.out.printf("There are %d rows and %d seats in each row " + "in the cinema hall.", numOfRows,
				numOfSeatsInEachRow);
		// Initialise an array of numbers
		// This contains 4 rows of 6 seats
		// If seat is empty, initialise with seat numbers
		String[][] movieSeats = new String[][] { { "A1", "A2", "A3", "A4", "A5", "A6" },
				{ "B1", "B2", "B3", "B4", "B5", "B6" }, { "C1", "C2", "C3", "C4", "C5", "C6" },
				{ "D1", "D2", "D3", "D4", "D5", "D6" }, };

		// Access the seat at D3
		System.out.println("The seat at D3 is unallocated : " + movieSeats[3][2]);
		System.out.println("Assiging the seat to Bob by modifying the item at movieSeats[3][2].");

		// Allocate the D3 to Bob
		movieSeats[3][2] = "Bob";
		System.out.println("The seat at D3 is occupied by : " + movieSeats[3][2]);
	}

	/**
	 * Try 3-D array
	 */
	public void try3DArray() {
		System.out.println("\n\nTrying the 3-D array");
		System.out.println("====================");

		int numfOfPages = 4;
		int numOfLines = 40;
		int numOfWords = 10;

		System.out.printf("There are %d pages in the book.\n", numfOfPages);
		System.out.printf("There are %d lines on a page.\n", numOfLines);
		System.out.printf("There are %d words in a line.\n", numOfWords);

		// Initialise an array of pages, lines and words
		String[][][] pagesLinesWords = new String[][][] { 
			{ // Page 1
				{ "This ", "is page 1 : ", "first line", "wrngly", "spelled", "word" }, // Line 1
				{ "This ", "is page 1 :  ", "second line", "correctly", "spelled", "word" }, // Line 2
				{ "This ", "is page 1 :  ", "thrid line", "correctly", "spelled", "word" }, // Line 3
				{ "This ", "is page 1 :  ", "fourth line", "wrngly", "spelled", "word" }, // Line 4
			}, { // Page 2
					{ "This ", "is page 2 : ", "first line", "wrngly", "phrased", "word" }, // Line 1
					{ "This ", "is page 2 : ", "second line", "correctly", "phrased", "word" }, // Line 2
					{ "This ", "is page 2 : ", "thrid line", "correctly", "phrased", "word" }, // Line 3
					{ "This ", "is page 2 : ", "fourth line", "wrngly", "phrased", "word" }, // Line 4
			}, { // Page 3
					{ "This ", "is page 3 : ", "first line", "wrngly", "spelled", "word" }, // Line 1
					{ "This ", "is page 3 : ", "second line", "correctly", "spelled", "word" }, // Line 2
					{ "This ", "is page 3 : ", "thrid line", "correctly", "spelled", "word" }, // Line 3
					{ "This ", "is page 3 : ", "fourth line", "wrngly", "spelled", "word" }, // Line 4
			}, { // Page 4
					{ "This ", "is page 4 : ", "first line", "wrngly", "spelled", "word" }, // Line 1
					{ "This ", "is page 4 : ", "second line", "correctly", "spelled", "word" }, // Line 2
					{ "This ", "is page 4 : ", "thrid line", "correctly", "spelled", "word" }, // Line 3
					{ "This ", "is page 4 : ", "fourth line", "wrngly", "spelled", "word" }, // Line 4
			} 
		};

		// Access the 4th word on page 1, line 1
		System.out.println("\nThe line on page 1, line 1 is ==> [" + String.join(" ", pagesLinesWords[0][0]) + "]");
		System.out.println(
				"The word on page 1, line 1 is 4th word is " + "wrongly spelled ==> " + pagesLinesWords[0][0][3]);
		System.out.println("\nCorrecting the word by modifying array element pagesLinesWords[0][0][3].");

		// Modify the word
		pagesLinesWords[0][0][3] = "correctly";

		System.out.println("The word on page 1, line 1 is 4th word after correction ==> " + pagesLinesWords[0][0][3] + ".");

	}
	

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		MultidimensionalArrayExample multidimensionalArrays = new MultidimensionalArrayExample();

		// Initialise 1-D array and, access and modify one of the elements
		multidimensionalArrays.try1DArray();

		// Initialise 2-D array and, access and modify one of the elements
		multidimensionalArrays.try3DArray();

		// Initialise 3-D array and, access and modify one of the elements
		multidimensionalArrays.try3DArray();

	}

}
